#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "merge-FrodoII.h"

#define MAX_CHAR_IN_A_LINE	576		//16*32=512 +64=72*8

int change_header_endian(CONTROL_HEADER_ID con_header)
{
	con_header->offset_1 = fnm_convert_ul_endian(con_header->offset_1);
	con_header->len_1 = fnm_convert_ul_endian(con_header->len_1);
	con_header->offset_2 = fnm_convert_ul_endian(con_header->offset_2);
	con_header->len_2 = fnm_convert_ul_endian(con_header->len_2);
	con_header->offset_3 = fnm_convert_ul_endian(con_header->offset_3);
	con_header->len_3 = fnm_convert_ul_endian(con_header->len_3);
}
	
unsigned long cal_check_sum(char *file_name)
{
	unsigned long	checksum=0;
	unsigned long	len, i, j;
	unsigned long	*buf;
	int				fd;
	
	buf = malloc(BLOCK_SIZE);
	
	fd = open(file_name, O_RDONLY);
	if( fd == -1 )
	{
		printf("Error: Can't open %s file !\n", file_name);
		return 0;
	}
	
	i=0;
	while(1)
	{
		len = BLOCK_SIZE;
		lseek(fd, i, SEEK_SET);
		len = read(fd, buf, len);

		for(j=0; j<(len/4); j++)
		{
			checksum ^= buf[j];
		}
		if(len != BLOCK_SIZE)
		{
			break;
		}
		i += len;
	}
	close(fd);
	
	return checksum;
}


int main(int argc, char **argv)
{
	CONTROL_HEADER	con_header, big_con_header;
	struct stat 	buf;
	unsigned char	*wbuf;
	char			tmp[64];
	int				fd1, fd2;
	unsigned long	len, i;
    FILE    		*fp1;
	char    		line[MAX_CHAR_IN_A_LINE];
	char			*name[3] = {"#define PRODUCT_ID ", "#define CUSTOM_ID ", "#define MODEL_ID "};
	char			*p;
	PEXTEND_ELEMENTS = EXTEND_ELEMENTS;	//+Wilson02132006
	
	//system("./cpfiles");
	//allocate write buffer
	wbuf = malloc(BLOCK_SIZE);
	if ( wbuf == NULL )
	{
		printf("Erroe: Allocate write buffer failed!\n");
		return;	
	}
	
	//set con_header structure to 0
	memset(&con_header, 0, sizeof(con_header));
	printf("size of structure = %d\n", sizeof(con_header));
	
#if 0
	//check input value
	if(argc>4)
	{
		printf("Usage: 3xmerge [Poduct_ID] [Custom_ID] [Model_ID]\n");
		return;
	}
	else if(argc == 1)
	{
		con_header.product_id = 0x0;
		con_header.custom_id = 0x0;
		con_header.model_id = 0x0;
	}
	else if((argc == 2) || (argc == 3))
	{
		printf("Usage: 3xmerge [Poduct_ID] [Custom_ID] [Model_ID]\n");
		return;
	}
	else
	{
		sscanf(argv[1], "%x", &(con_header.product_id));
		sscanf(argv[2], "%x", &(con_header.custom_id));
		sscanf(argv[3], "%x", &(con_header.model_id));
	}
#else
    if((fp1 = fopen(CUSTOM_PATH,"r")) == NULL)
     {
     	printf("custom.h file error \n");
     	return;
     }	

   	for(i = 0; i<3 ; i++)
	{
		if(fgets(line, MAX_CHAR_IN_A_LINE, fp1) != NULL)
		{
			p = (char *)strtok(line, name[i]);
			if(p == NULL)
			{
				printf("p = NULL \n");
				fclose(fp1);
				return;
			}
			else
			{	
				if(i == 0)
					con_header.product_id = atoi(p);
				else if(i == 1)
					con_header.custom_id = atoi(p);
				else
					con_header.model_id = atoi(p);	
			}	
		}
	}
	fclose(fp1);	
#endif
	
	con_header.sub_id = 0x01;
	//print id to check
	printf("Product ID = %x\n", con_header.product_id);
	printf("Custom  ID = %x\n", con_header.custom_id);
	printf("Model   ID = %x\n", con_header.model_id);
	printf("Sub     ID = %x\n", con_header.sub_id);
	
	//delete output file, we will make a new one
	sprintf(tmp, "rm -f %s", MERGED_FILE);
	system(tmp);
	
	//fill control header
	con_header.offset_1 = sizeof(con_header);
	lstat(KERNEL_FILE, &buf);
	con_header.len_1 = buf.st_size;
	
	con_header.offset_2 = sizeof(con_header)+con_header.len_1;
	lstat(RAMDISK_FILE, &buf);
	con_header.len_2 = buf.st_size;
	
	con_header.offset_3 = sizeof(con_header)+con_header.len_1+con_header.len_2;
	lstat(TAR_FILE, &buf);
	con_header.len_3 = buf.st_size;
	
//+Wilson02132006
//Check for extended element exist or not
if( PEXTEND_ELEMENTS->Directory != NULL )
{
//axl20051227++
	con_header.Next_offset = sizeof(con_header)+con_header.len_1+con_header.len_2+con_header.len_3;
//axl20051227--
}
else
	con_header.Next_offset = 0;
//Wilson02132006+

	//check offset and len
	printf("CH off 1 = %d\n", con_header.offset_1);
	printf("CH len 1 = %ld\n", con_header.len_1);
	printf("CH off 2 = %d\n", con_header.offset_2);
	printf("CH len 2 = %ld\n", con_header.len_2);
	printf("CH off 3 = %d\n", con_header.offset_3);
	printf("CH len 3 = %ld\n", con_header.len_3);
	
	
	//open file to write
	fd1 = open(MERGED_FILE, O_RDWR | O_CREAT | O_TRUNC);
	if( fd1 == -1 )
	{
		printf("Error: Can't open %s file !\n", MERGED_FILE);
		return;
	}
	
	//magic number
//	strncpy(con_header.magic_num, ARWEN_MAGIC_NUM, 12);
	memcpy(con_header.magic_num, FRODO2_MAGIC_NUM, 12);
	
	//calculate merged file check sum
	con_header.checksum_1 = cal_check_sum(KERNEL_FILE);
	con_header.checksum_2 = cal_check_sum(RAMDISK_FILE);
	con_header.checksum_3 = cal_check_sum(TAR_FILE);
	printf("CH checksum 1 = %lX\n", con_header.checksum_1);
	printf("CH checksum 2 = %lX\n", con_header.checksum_2);
	printf("CH checksum 3 = %lX\n", con_header.checksum_3);
	
	printf("Next_offset = 0x%8.8x\n", con_header.Next_offset);
	
	memcpy(&big_con_header, &con_header, sizeof(con_header));
	//change_header_endian(&big_con_header);		//+Bing modified 05242005
	
	//write control header to file
	lseek(fd1, 0, SEEK_SET);
	write(fd1, &big_con_header, sizeof(con_header));
	
	//open kernel file to read
	fd2 = open(KERNEL_FILE, O_RDONLY);
	if( fd2 == -1 )
	{
		printf("Error: Can't open %s file !\n", KERNEL_FILE);
		close(fd1);
		return;
	}
	
	//read kernel content and write to file
	i = 0;
	while(1)
	{
		len = BLOCK_SIZE;
		lseek(fd1, i+sizeof(con_header), SEEK_SET);
		lseek(fd2, i, SEEK_SET);
		len = read(fd2, wbuf, len);
		write(fd1, wbuf, len);
		if(len != BLOCK_SIZE)
		{
			break;
		}
		i += len;
	}
	close(fd2);
	
	//read ramdisk file and write to file
	fd2 = open(RAMDISK_FILE, O_RDONLY);
	if( fd2 == -1 )
	{
		printf("Error: Can't open %s file !\n", RAMDISK_FILE);
		close(fd1);
		return;
	}
	i = 0;
	while(1)
	{
		len = BLOCK_SIZE;
		lseek(fd1, i+con_header.len_1+sizeof(con_header), SEEK_SET);
		lseek(fd2, i, SEEK_SET);
		len = read(fd2, wbuf, len);
		write(fd1, wbuf, len);
		if(len != BLOCK_SIZE)
		{
			break;
		}
		i += len;
	}
	close(fd2);
	
	//read default.tar.gz file and write to file
	fd2 = open(TAR_FILE, O_RDONLY);
	if( fd2 == -1 )
	{
		printf("Error: Can't open %s file !\n", TAR_FILE);
		close(fd1);
		return;
	}
	i = 0;
	while(1)
	{
		len = BLOCK_SIZE;
		lseek(fd1, i+con_header.len_1+con_header.len_2+sizeof(con_header), SEEK_SET);
		lseek(fd2, i, SEEK_SET);
		len = read(fd2, wbuf, len);
		write(fd1, wbuf, len);
		if(len != BLOCK_SIZE)
		{
			break;
		}
		i += len;
	}
	close(fd2);

	//+Wilson02132006
	if( PEXTEND_ELEMENTS->Directory != NULL )
	{
	
		EXTEND_HEADER	extendHeader;
		unsigned long	LastOffset = con_header.Next_offset;	//+Wilson02132006
		
		for(PEXTEND_ELEMENTS = EXTEND_ELEMENTS; PEXTEND_ELEMENTS->Directory; PEXTEND_ELEMENTS++)
		{
			//set extendHeader structure to 0
			memset(&extendHeader, 0, sizeof(extendHeader));
	
			//file install path and file name
			strcpy(extendHeader.Directory, PEXTEND_ELEMENTS->Directory);
			strcpy(extendHeader.FileName, PEXTEND_ELEMENTS->FileName);
			
			#ifdef DBG
				printf("Directory = %s, Filename = %s",PEXTEND_ELEMENTS->Directory,PEXTEND_ELEMENTS->FileName);
			#endif
	
			//file mode and execute?
			extendHeader.chmod 		= 755;
			extendHeader.execute 	= 0;
	
			//file offset
			extendHeader.offset = sizeof(extendHeader)+LastOffset;
	
			//file len
			lstat(PEXTEND_ELEMENTS->FileName, &buf);
			extendHeader.len = buf.st_size;
	
			//checksum
			extendHeader.checksum = cal_check_sum(PEXTEND_ELEMENTS->FileName);
	
			//fill next offset
			if( (PEXTEND_ELEMENTS+1)->Directory == NULL )
				extendHeader.Next_offset = 0;
			else
				extendHeader.Next_offset = extendHeader.offset+extendHeader.len;

			printf("==========================================================\n");
			printf("File Name: %s/%s\n", extendHeader.Directory, PEXTEND_ELEMENTS->FileName);
			printf("EX offset   = 0x%8.8X\n", extendHeader.offset);
			printf("EX len      = %ld\n", extendHeader.len);
			printf("EX checksum = 0x%8.8X\n", extendHeader.checksum);
			printf("Next_offset = 0x%8.8x\n", extendHeader.Next_offset);

			write(fd1, &extendHeader, sizeof(extendHeader));

			//read the file and write to the firmware
			fd2 = open(PEXTEND_ELEMENTS->FileName, O_RDONLY);
			if( fd2 == -1 )
			{
				printf("Error: Can't open %s file !\n", PEXTEND_ELEMENTS->FileName);
				close(fd1);
				return;
			}
			i = 0;
			while(1)
			{
				len = BLOCK_SIZE;
				lseek(fd1, i+LastOffset+sizeof(extendHeader), SEEK_SET);
				lseek(fd2, i, SEEK_SET);
				len = read(fd2, wbuf, len);
				write(fd1, wbuf, len);
				if(len != BLOCK_SIZE)
				{
					#ifdef DBG
						printf("len = %d\n", len);
					#endif
					break;
				}
				i += len;
			}
			close(fd2);
			LastOffset = extendHeader.Next_offset;
		}
	}
	//Wilson02132006+
	
	//close fd of merged file
	close(fd1);
	
	//chmod for merged file
	sprintf(tmp, "chmod 777 %s", MERGED_FILE);
	system(tmp);

}

